#line 1 "F:/MikroC/ModbusSlave/ModbusSlave.c"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for pic/include/built_in.h"
#line 1 "f:/mikroc/modbusslave/modbusslave.h"
#line 1 "f:/mikroc/modbusslave/types.h"
#line 14 "f:/mikroc/modbusslave/types.h"
 typedef unsigned long ulong;


 typedef unsigned int uint;


 typedef unsigned short ushort;


 typedef unsigned char byte;


 typedef enum ebool { FALSE, TRUE } boolean;
#line 33 "f:/mikroc/modbusslave/modbusslave.h"
 typedef struct {
 byte bytHi;
 byte bytLo;
 } hiloDef;

 typedef enum eBaudRates {
 BAUD_1200 = 12,
 BAUD_2400 = 24,
 BAUD_4800 = 48,
 BAUD_9600 = 96,
 BAUD_19200 = 192,
 BAUD_38400 = 384,
 BAUD_57600 = 576,
 BAUD_115200 = 1152
 } baudRate;

 typedef enum eModbusFunctions {
 READ_COILS = 1,
 READ_STATUS_INPUTS = 2,
 READ_HOLDING_REGISTERS = 3,
 READ_INPUT_REGISTERS = 4,
 FORCE_SINGLE_COIL = 5,
 PRESET_SINGLE_REGISTER = 6,
 FORCE_MULTIPLE_COILS = 15,
 PRESET_MULTIPLE_REGISTERS = 16
 } mbFunction;

 typedef enum eModbusExceptions {
 NO_EXCEPTION = 0,
 ILLEGAL_FUNCTION = 1,
 ILLEGAL_DATA_ADDRESS = 2,
 ILLEGAL_DATA_VALUE = 3,
 SLAVE_DEVICE_FAILURE = 4,
 ACKNOWLEDGE = 5,
 SLAVE_DEVICE_BUSY = 6,
 NEGATIVE_ACKNOWLEDGE = 7,
 MEMORY_PARITY_ERROR = 8
 } mbException;

 typedef struct _discrete {

 uint uintAddress;

 ushort* pByte;

 byte bBit;

 struct _discrete* pNext;
 } discreteDef;

 typedef discreteDef coilDef;
 typedef discreteDef statusDef;


 typedef struct {
 byte bytSlave;
 byte bytFunction;
 hiloDef addr;
 hiloDef points;
 hiloDef crc;
 } reqDataDef;

 typedef reqDataDef reqCoilsDef;
 typedef reqDataDef reqStatusDef;
 typedef reqDataDef reqHoldReqDef;
 typedef reqDataDef reqInputsDef;

 typedef struct _register {

 uint uintAddress;

 ushort* pWord;

 struct _register* pNext;
 } registerDef;

 typedef registerDef inputDef;
 typedef registerDef holdingDef;

 boolean addCoil(coilDef* pCoil,
 uint uintAddress, ushort* pByte, byte bBit);
 boolean addHoldingReg(holdingDef* pHolding,
 uint uintAddress, ushort* pWord);
 boolean addInputReg(inputDef* pInput,
 uint uintAddress, ushort* pWord);
 boolean addStatusBit(statusDef* pStatus,
 uint uintAddress, ushort* pByte, byte bBit);
 void decodePacket(void);
 int modbusSlave(baudRate eBaud, const byte bytAddress);
#line 39 "F:/MikroC/ModbusSlave/ModbusSlave.c"
static coilDef* pLastCoil =  ((void*)0) ;
static statusDef* pLastStatusBit =  ((void*)0) ;
static inputDef* pLastInput =  ((void*)0) ;
static holdingDef* pLastHoldingReg =  ((void*)0) ;

static coilDef* pCoils =  ((void*)0) ;
static statusDef* pStatusBits =  ((void*)0) ;
static inputDef* pInputs =  ((void*)0) ;
static holdingDef* pHoldingRegs =  ((void*)0) ;

static boolean blnValidStart, blnValidEnd;

static mbException exceptionCode;

static byte bytSlaveAddress;

static byte bytStartHi, bytStartLo;

static byte bytTotalHi, bytTotalLo;

static byte bytIndex = 0;

static uint uintRxGapSetPt;

static uint uintRxGap;

static byte aryBuffer[ 255 ];
static byte bytRxphase;
#line 82 "F:/MikroC/ModbusSlave/ModbusSlave.c"
static boolean addDiscrete(discreteDef* pDiscrete,
 uint uintAddress,
 ushort* pByte, byte bBit,
 discreteDef** pLinkList,
 discreteDef** pLast) {
 if ( !(pDiscrete && uintAddress && pByte &&
 bBit >= 0 && bBit < 8 && pLinkList && pLast) ) {
 return FALSE;
 }
 if ( *pLinkList ==  ((void*)0)  ) {

 *pLinkList = *pLast = pDiscrete;
 } else {

 (*pLast)->pNext = pDiscrete;

 *pLast = pDiscrete;
 }

 pDiscrete->uintAddress = uintAddress;
 pDiscrete->pByte = pByte;
 pDiscrete->bBit = bBit;
 pDiscrete->pNext =  ((void*)0) ;
}
#line 120 "F:/MikroC/ModbusSlave/ModbusSlave.c"
static boolean addRegister(registerDef* pRegister,
 uint uintAddress,
 ushort* pWord,
 registerDef** pLinkList,
 registerDef** pLast) {
 if ( !(pRegister && uintAddress && pWord && pLinkList && pLast) ) {
 return FALSE;
 }
 if ( *pLinkList ==  ((void*)0)  ) {

 *pLinkList = *pLast = pRegister;
 } else {

 (*pLast)->pNext = pRegister;

 *pLast = pRegister;
 }

 pRegister->uintAddress = uintAddress;
 pRegister->pWord = pWord;
 pRegister->pNext =  ((void*)0) ;
}
#line 152 "F:/MikroC/ModbusSlave/ModbusSlave.c"
static uint calcCRC(uint uintLength) {
 static code byte arybytHi[] = {
 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0,
 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41,
 0x00, 0xC1, 0x81, 0x40, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0,
 0x80, 0x41, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40,
 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1,
 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0, 0x80, 0x41,
 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1,
 0x81, 0x40, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41,
 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0,
 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x00, 0xC1, 0x81, 0x40,
 0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1,
 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40,
 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0,
 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x00, 0xC1, 0x81, 0x40,
 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0,
 0x80, 0x41, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40,
 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0,
 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41,
 0x00, 0xC1, 0x81, 0x40, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0,
 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41,
 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0,
 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x00, 0xC1, 0x81, 0x40,
 0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1,
 0x81, 0x40, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41,
 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0,
 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40 };
 static code char arybytLo[] = {
 0x00, 0xC0, 0xC1, 0x01, 0xC3, 0x03, 0x02, 0xC2, 0xC6, 0x06,
 0x07, 0xC7, 0x05, 0xC5, 0xC4, 0x04, 0xCC, 0x0C, 0x0D, 0xCD,
 0x0F, 0xCF, 0xCE, 0x0E, 0x0A, 0xCA, 0xCB, 0x0B, 0xC9, 0x09,
 0x08, 0xC8, 0xD8, 0x18, 0x19, 0xD9, 0x1B, 0xDB, 0xDA, 0x1A,
 0x1E, 0xDE, 0xDF, 0x1F, 0xDD, 0x1D, 0x1C, 0xDC, 0x14, 0xD4,
 0xD5, 0x15, 0xD7, 0x17, 0x16, 0xD6, 0xD2, 0x12, 0x13, 0xD3,
 0x11, 0xD1, 0xD0, 0x10, 0xF0, 0x30, 0x31, 0xF1, 0x33, 0xF3,
 0xF2, 0x32, 0x36, 0xF6, 0xF7, 0x37, 0xF5, 0x35, 0x34, 0xF4,
 0x3C, 0xFC, 0xFD, 0x3D, 0xFF, 0x3F, 0x3E, 0xFE, 0xFA, 0x3A,
 0x3B, 0xFB, 0x39, 0xF9, 0xF8, 0x38, 0x28, 0xE8, 0xE9, 0x29,
 0xEB, 0x2B, 0x2A, 0xEA, 0xEE, 0x2E, 0x2F, 0xEF, 0x2D, 0xED,
 0xEC, 0x2C, 0xE4, 0x24, 0x25, 0xE5, 0x27, 0xE7, 0xE6, 0x26,
 0x22, 0xE2, 0xE3, 0x23, 0xE1, 0x21, 0x20, 0xE0, 0xA0, 0x60,
 0x61, 0xA1, 0x63, 0xA3, 0xA2, 0x62, 0x66, 0xA6, 0xA7, 0x67,
 0xA5, 0x65, 0x64, 0xA4, 0x6C, 0xAC, 0xAD, 0x6D, 0xAF, 0x6F,
 0x6E, 0xAE, 0xAA, 0x6A, 0x6B, 0xAB, 0x69, 0xA9, 0xA8, 0x68,
 0x78, 0xB8, 0xB9, 0x79, 0xBB, 0x7B, 0x7A, 0xBA, 0xBE, 0x7E,
 0x7F, 0xBF, 0x7D, 0xBD, 0xBC, 0x7C, 0xB4, 0x74, 0x75, 0xB5,
 0x77, 0xB7, 0xB6, 0x76, 0x72, 0xB2, 0xB3, 0x73, 0xB1, 0x71,
 0x70, 0xB0, 0x50, 0x90, 0x91, 0x51, 0x93, 0x53, 0x52, 0x92,
 0x96, 0x56, 0x57, 0x97, 0x55, 0x95, 0x94, 0x54, 0x9C, 0x5C,
 0x5D, 0x9D, 0x5F, 0x9F, 0x9E, 0x5E, 0x5A, 0x9A, 0x9B, 0x5B,
 0x99, 0x59, 0x58, 0x98, 0x88, 0x48, 0x49, 0x89, 0x4B, 0x8B,
 0x8A, 0x4A, 0x4E, 0x8E, 0x8F, 0x4F, 0x8D, 0x4D, 0x4C, 0x8C,
 0x44, 0x84, 0x85, 0x45, 0x87, 0x47, 0x46, 0x86, 0x82, 0x42,
 0x43, 0x83, 0x41, 0x81, 0x80, 0x40 };
 byte bytHi = 0xff, bytLo = 0xff;
 byte* pBuffer = aryBuffer;
 uint uintIdx;

 while( uintLength-- ) {
 uintIdx = bytHi ^ *pBuffer++;
 bytHi = bytLo ^ arybytHi[uintIdx];
 bytLo = arybytLo[uintIdx];
 }

 return (uint)(((uint)bytHi << 8) | bytLo);
}
#line 230 "F:/MikroC/ModbusSlave/ModbusSlave.c"
static void coilState(uint uintAddr, boolean eState) {

 discreteDef* pNode;
 byte bytMask;
 for( pNode=pCoils; pNode!= ((void*)0) ; pNode=pNode->pNext ) {
 if ( pNode->uintAddress != uintAddr ) {
 continue;
 }
 bytMask = (1 << pNode->bBit);

 if ( eState == TRUE ) {

 *pNode->pByte |= bytMask;
 } else {

 *pNode->pByte &= (0xffff ^ bytMask);
 }
 break;
 }
}
#line 263 "F:/MikroC/ModbusSlave/ModbusSlave.c"
static uint packBits(discreteDef* pLL, byte* pBuffer,
 uint uintStart, uint uintEnd) {

 uint uintBytes = 0, uintBit = 0;
 discreteDef* pNode;
 byte bytSet;
 for( pNode=pLL; pNode!= ((void*)0) ; pNode=pNode->pNext ) {
 if ( pNode->uintAddress >= uintStart && pNode->uintAddress <= uintEnd ) {
 bytSet = (*pNode->pByte & (1 << pNode->bBit)) ? 1 : 0;

 if ( bytSet ) {
 pBuffer[uintBytes] |= (bytSet << uintBit);
 }
 if ( ++uintBit > 7 ) {
 uintBit = 0;
 uintBytes++;
 }
 }
 }
 return uintBytes + 1;
}
#line 297 "F:/MikroC/ModbusSlave/ModbusSlave.c"
static uint packRegisters(registerDef* pLL, byte* pBuffer,
 uint uintStart, uint uintEnd) {

 uint uintBytes = 0;
 registerDef* pNode;
 for( pNode=pLL; pNode!= ((void*)0) ; pNode=pNode->pNext ) {
 if ( pNode->uintAddress >= uintStart && pNode->uintAddress <= uintEnd ) {
 pBuffer[uintBytes++] = (*pNode->pWord >> 0x08);
 pBuffer[uintBytes++] = (*pNode->pWord & 0xff);
 }
 }
 return uintBytes;
}
#line 322 "F:/MikroC/ModbusSlave/ModbusSlave.c"
static void setRegister(uint uintAddr, byte bytHi, byte bytLo) {

 registerDef* pNode;
 for( pNode=pHoldingRegs; pNode!= ((void*)0) ; pNode=pNode->pNext ) {
 if ( pNode->uintAddress != uintAddr ) {
 continue;
 }
 *pNode->pWord = ((int)bytHi << 0x08) | (int)bytLo;
 break;
 }
}
#line 343 "F:/MikroC/ModbusSlave/ModbusSlave.c"
static void startTimeout(void) {

 TMR0ON_bit = 0;

 TMR0H =  ((char *)&uintRxGapSetPt)[1] ;
 TMR0L =  ((char *)&uintRxGapSetPt)[0] ;

 TMR0IF_bit = 0;

 TMR0ON_bit = 1;
}
#line 366 "F:/MikroC/ModbusSlave/ModbusSlave.c"
static boolean validAddresses(uint uintAddress, uint uintStart, uint uintEnd) {
 if ( blnValidStart == FALSE && uintStart == uintAddress ) {
 blnValidStart = TRUE;
 }
 if ( blnValidEnd == FALSE && uintEnd == uintAddress ) {
 blnValidEnd = TRUE;
 }
 return (blnValidStart == TRUE && blnValidEnd == TRUE);
}
#line 387 "F:/MikroC/ModbusSlave/ModbusSlave.c"
static boolean validDiscretes(discreteDef* pLL, uint uintStart, uint uintEnd) {
 discreteDef* pNode;
 blnValidStart = blnValidEnd = FALSE;
 for( pNode=pLL; pNode!= ((void*)0) ; pNode=pNode->pNext ) {
 if ( validAddresses(pNode->uintAddress, uintStart, uintEnd) == TRUE ) {
 return TRUE;
 }
 }
 return FALSE;
}
#line 409 "F:/MikroC/ModbusSlave/ModbusSlave.c"
static boolean validRegisters(registerDef* pLL, uint uintStart, uint uintEnd) {
 registerDef* pNode;
 blnValidStart = blnValidEnd = FALSE;
 for( pNode=pLL; pNode!= ((void*)0) ; pNode=pNode->pNext ) {
 if ( validAddresses(pNode->uintAddress, uintStart, uintEnd) == TRUE ) {
 return TRUE;
 }
 }
 return FALSE;
}
#line 432 "F:/MikroC/ModbusSlave/ModbusSlave.c"
boolean addCoil(coilDef* pCoil, uint uintAddress, ushort* pByte, byte bBit) {
 return addDiscrete(pCoil, uintAddress, pByte, bBit, &pCoils, &pLastCoil);
}
#line 447 "F:/MikroC/ModbusSlave/ModbusSlave.c"
boolean addHoldingReg(holdingDef* pHolding, uint uintAddress, ushort* pWord) {
 return addRegister(pHolding, uintAddress, pWord, &pHoldingRegs,
 &pLastHoldingReg);
}
#line 463 "F:/MikroC/ModbusSlave/ModbusSlave.c"
boolean addInputReg(inputDef* pInput, uint uintAddress, ushort* pWord) {
 return addRegister(pInput, uintAddress, pWord, &pInputs, &pLastInput);
}
#line 479 "F:/MikroC/ModbusSlave/ModbusSlave.c"
boolean addStatusBit(statusDef* pStatus, uint uintAddress, ushort* pByte,
 byte bBit) {
 return addDiscrete(pStatus, uintAddress, pByte, bBit, &pStatusBits,
 &pLastStatusBit);
}
#line 494 "F:/MikroC/ModbusSlave/ModbusSlave.c"
void decodePacket(void) {
 uint uintCRCpos = 0, uintCRC;

 if ( TMR0IF_bit ) {
 bytRxphase++;
 TMR0ON_bit = 0;

 TMR0IF_bit = 0;
 }
 if( RCIF_bit ) {
 byte bytTemp;
 bytTemp = UART_Read();


 if ( bytRxphase == 0 ||
 bytIndex >=  255  ||
 (bytRxphase == 1 && bytTemp != bytSlaveAddress) ) {
 bytIndex = 0;
 bytRxphase = 0;
 startTimeout();
 return;
 }
 if ( bytIndex == 0) {

 bytRxphase++;
 }

 aryBuffer[bytIndex++] = (byte)bytTemp;

 startTimeout();
 }
 if ( bytRxphase < 3 ) {

 return;
 }

 uintCRCpos = 6;

 switch( aryBuffer[1] ) {
 case READ_COILS:
 case FORCE_SINGLE_COIL:
 case FORCE_MULTIPLE_COILS:
 if ( pCoils ==  ((void*)0)  ) {

 exceptionCode = ILLEGAL_DATA_ADDRESS;
 }
 break;
 case READ_STATUS_INPUTS:
 if ( pStatusBits ==  ((void*)0)  ) {

 exceptionCode = ILLEGAL_DATA_ADDRESS;
 }
 break;
 case READ_HOLDING_REGISTERS:
 case PRESET_SINGLE_REGISTER:
 case PRESET_MULTIPLE_REGISTERS:
 if ( pHoldingRegs ==  ((void*)0)  ) {

 exceptionCode = ILLEGAL_DATA_ADDRESS;
 }
 break;
 case READ_INPUT_REGISTERS:
 if ( pInputs ==  ((void*)0)  ) {

 exceptionCode = ILLEGAL_DATA_ADDRESS;
 }
 break;
 default:

 exceptionCode = ILLEGAL_FUNCTION;
 break;
 }
 bytStartHi = aryBuffer[2];
 bytStartLo = aryBuffer[3];
 bytTotalHi = aryBuffer[4];
 bytTotalLo = aryBuffer[5];

 if ( aryBuffer[1] == FORCE_MULTIPLE_COILS ||
 aryBuffer[1] == PRESET_MULTIPLE_REGISTERS ) {
 uintCRCpos += 1 + aryBuffer[6];
 }

 uintCRC = calcCRC(uintCRCpos);

 if ( (uintCRC >> 0x08) == aryBuffer[uintCRCpos] &&
 (uintCRC & 0xff) == aryBuffer[uintCRCpos + 1] ) {

 uint uintSAddr, uintEAddr, uintItemCount, uintLength = 6;
 uint uintOffset, uintAddr, uintBit;
 discreteDef* pDiscretes;
 registerDef* pRegisters;

 uintSAddr = (((uint)bytStartHi << 0x08) | bytStartLo) + 1;

 uintItemCount = ((uint)bytTotalHi << 0x08) | bytTotalLo;

 uintEAddr = uintSAddr + uintItemCount - 1;

 switch( aryBuffer[1] ) {
 case READ_COILS:
 case READ_STATUS_INPUTS:
 if ( aryBuffer[1] == READ_COILS ) {
 pDiscretes = pCoils;
 } else {
 pDiscretes = pStatusBits;
 }
 if ( validDiscretes(pDiscretes, uintSAddr, uintEAddr) == FALSE ) {
 exceptionCode = ILLEGAL_DATA_ADDRESS;

 } else {
 aryBuffer[2] = packBits(pDiscretes,
 &aryBuffer[3],
 uintSAddr, uintEAddr);
 uintLength = aryBuffer[2] + 3;
 }
 break;
 case READ_HOLDING_REGISTERS:
 case READ_INPUT_REGISTERS:
 case READ_STATUS_INPUTS:
 if ( aryBuffer[1] == READ_INPUT_REGISTERS ) {
 pRegisters = pInputs;
 } else {
 pRegisters = pHoldingRegs;
 }
 if ( validRegisters(pRegisters, uintSAddr, uintEAddr) == FALSE ) {

 exceptionCode = ILLEGAL_DATA_ADDRESS;
 } else {
 aryBuffer[2] = packRegisters(pRegisters,
 &aryBuffer[3],
 uintSAddr, uintEAddr);
 uintLength = aryBuffer[2] + 3;
 }
 break;
 case FORCE_SINGLE_COIL:
 if ( validDiscretes(pCoils, uintSAddr, uintSAddr) == FALSE ) {

 exceptionCode = ILLEGAL_DATA_ADDRESS;
 } else {
 if ( aryBuffer[4] == 0xff && aryBuffer[5] == 0x0 ) {

 coilState(uintSAddr, TRUE);
 } else if ( aryBuffer[4] == 0x0 && aryBuffer[5] == 0x0 ) {

 coilState(uintSAddr, FALSE);
 }
 }
 break;
 case PRESET_SINGLE_REGISTER:
 if ( validRegisters(pHoldingRegs, uintSAddr, uintSAddr) == FALSE ) {

 exceptionCode = ILLEGAL_DATA_ADDRESS;
 } else {
 setRegister(uintSAddr, aryBuffer[4], aryBuffer[5]);
 }
 break;
 case FORCE_MULTIPLE_COILS:
 if ( uintItemCount >  1976  ||
 uintItemCount > (aryBuffer[6] * 8) ) {

 exceptionCode = ILLEGAL_DATA_ADDRESS;
 break;
 }
 case PRESET_MULTIPLE_REGISTERS:
 if ( (aryBuffer[1] == PRESET_MULTIPLE_REGISTERS &&
 uintItemCount >  123 ) ) {

 exceptionCode = ILLEGAL_DATA_ADDRESS;
 } else if ( validDiscretes(pCoils,
 uintSAddr, uintEAddr) == FALSE ) {
 aryBuffer[1] |=  0x80 ;
 } else {
 uintOffset = 0;
 uintAddr = uintSAddr;

 while( uintAddr<=uintEAddr ) {
 if ( aryBuffer[1] == PRESET_MULTIPLE_REGISTERS ) {
 setRegister(uintAddr,
 aryBuffer[7 + uintOffset],
 aryBuffer[8 + uintOffset]);
 uintOffset += 2;
 } else {
 for(uintBit=0; uintBit<8; uintBit++, uintAddr++ ) {
 coilState(uintAddr,
 aryBuffer[7 + uintOffset] & (1 << uintBit));
 }
 uintOffset++;
 }
 uintAddr++;
 }
 }
 break;
 }
 if( exceptionCode != NO_EXCEPTION ) {
 aryBuffer[1] |=  0x80 ;
 aryBuffer[2] = (byte)exceptionCode;
 exceptionCode = NO_EXCEPTION;
 uintLength = 3;
 }
 if ( uintLength > 0 ) {

 uintCRC = calcCRC(uintLength);
 aryBuffer[uintLength] = (uintCRC >> 0x08);
 uintLength++;
 aryBuffer[uintLength] = (uintCRC & 0xff);
 uintLength++;

 for( bytIndex=0; bytIndex<uintLength; bytIndex++ ) {
 UART1_Write(aryBuffer[bytIndex]);
 }

 while( !TXSTA.TRMT ) ;

 bytIndex = 0;
 bytRxphase = 0;
 startTimeout();
 }
 }
}
#line 724 "F:/MikroC/ModbusSlave/ModbusSlave.c"
int modbusSlave(baudRate eBaud, const byte bytAddress) {
 long lngTimeoutPreset;
 byte bytTemp;

 if ( bytAddress < 1 ) {
 return -1;
 }

 memset(aryBuffer, 0, sizeof(aryBuffer));

 bytSlaveAddress = bytAddress;

 uintRxGap = 0;

 exceptionCode = NO_EXCEPTION;

 switch( eBaud ) {
 case BAUD_1200:
 UART1_Init(BAUD_1200 * 100);
 break;
 case BAUD_2400:
 UART1_Init(BAUD_2400 * 100);
 break;
 case BAUD_4800:
 UART1_Init(BAUD_4800 * 100);
 break;
 case BAUD_9600:
 UART1_Init(BAUD_9600 * 100);
 break;
 case BAUD_19200:
 UART1_Init(BAUD_19200 * 100);
 break;
 case BAUD_38400:
 UART1_Init(BAUD_38400 * 100);
 break;
 case BAUD_57600:
 UART1_Init(BAUD_57600 * 100);
 break;
 case BAUD_115200:
 UART1_Init(BAUD_115200 * 100);
 break;
 default:
 return -1;
 }

 lngTimeoutPreset =  495  * Clock_kHz() / (4 * eBaud);

 Delay_ms(100);







 T0CON.TMR0ON = 1;
 T0CON.T08BIT = 0;
 T0CON.T0CS = 0;
 T0CON.T0SE = 0;
 T0CON.PSA = 1;
 T0CON.T0PS2 = 0;
 T0CON.T0PS1 = 0;
 T0CON.T0PS0 = 0;

 bytTemp = 0;
 while( lngTimeoutPreset > 65535 ) {
 lngTimeoutPreset >>= 1;
 bytTemp++;
 }
 if ( bytTemp > 0 && bytTemp <= 8 ) {
 T0CON.PSA = 0;
 T0CON = T0CON | (--bytTemp & 0x07);
 }
 uintRxGapSetPt = (uint)-lngTimeoutPreset;

 bytRxphase = RCREG;
 bytRxphase = RCREG;
 RCSTA.CREN = 0;
 RCSTA.CREN = 1;
 bytRxphase = 0;
 bytIndex = 0;
 RCIF_bit = 0;

 startTimeout();
 TMR0IE_bit = 1;

 RC1IE_bit = 1;

 PEIE_bit = 1;

 GIE_bit = 1;
 return 0;
}
